using C1.Win.SplitContainer;

namespace DashBoardTest
{
    public partial class FormSplit : Form
    {
        public FormSplit()
        {
            InitializeComponent();

            //this.c1DashboardLayout1.SplitLayoutControl.LineBelowHeader = false;



            /*
            //Test: Replace contextmenu with custom menu - replaces the menu of the "ToolIconButton".
            //https://developer.mescius.com/componentone/docs/win/online-dashboardlayout/creatingcustomcontextmenu.html
            ContextMenuStrip customContextMenu = new ContextMenuStrip();
            customContextMenu.Items.Add("One");
            customContextMenu.Items.Add("Two");
            customContextMenu.Items.Add("Three");
            this.c1DashboardLayout1.Options.ContextMenuStrip = customContextMenu;
            */

            //this.c1DashboardLayout1.Options.HeaderAppearance = C1.Win.Layout.HeaderAppearance.Empty;
            //this.c1DashboardLayout1.Options.HeaderAppearance = C1.Win.Layout.HeaderAppearance.ToolIconButton;
            this.c1DashboardLayout1.Options.HeaderAppearance = C1.Win.Layout.HeaderAppearance.MaximizeButton;
        }

        private void buttonCreate_Click(object sender, EventArgs e)
        {
            this.c1DashboardLayout1.SuspendLayout();
            this.c1DashboardLayout1.SplitLayoutControl.SuspendLayout();


            this.c1DashboardLayout1.LayoutType = C1.Win.Layout.LayoutType.Split;


            //Leer machen:
            this.c1DashboardLayout1.SplitLayoutControl.Panels.Clear(true);

            //Root-Split vertical:
            //C1SplitContainer splitContainerRoot = new C1SplitContainer();
            C1SplitterPanel c1SplitterPanelRootLinks = new C1SplitterPanel();
            c1SplitterPanelRootLinks.Text = "Root links";
            c1SplitterPanelRootLinks.Dock = PanelDockStyle.Left;
            c1SplitterPanelRootLinks.Name = "c1SplitterPanelRootLinks";
            //splitContainerRoot.Panels.Add(c1SplitterPanelRootLinks);
            this.c1DashboardLayout1.SplitLayoutControl.Panels.Add(c1SplitterPanelRootLinks);


            C1SplitterPanel c1SplitterPanelRootRechts = new C1SplitterPanel();
            c1SplitterPanelRootRechts.Text = "Root rechts";
            c1SplitterPanelRootRechts.Dock = PanelDockStyle.Right;
            c1SplitterPanelRootRechts.Name = "c1SplitterPanelRootRechts";
            //splitContainerRoot.Panels.Add(c1SplitterPanelRootRechts);
            this.c1DashboardLayout1.SplitLayoutControl.Panels.Add(c1SplitterPanelRootRechts);


            C1SplitContainer c1SplitContainerLinks = new C1SplitContainer();
            c1SplitContainerLinks.Dock = DockStyle.Fill;
            c1SplitterPanelRootLinks.Controls.Add(c1SplitContainerLinks);

            //Level 1 Split links:
            C1SplitterPanel c1SplitterPanel1 = new C1SplitterPanel();
            c1SplitterPanel1.Text = "Split 1";
            c1SplitterPanel1.Name = "c1SplitterPanel1";
            c1SplitterPanel1.SizeRatio = 33;

            MyFlex1 flex1 = new MyFlex1();
            flex1.Dock = DockStyle.Fill;
            Panel panelFlex1 = new Panel();
            //Padding/Margin:
            panelFlex1.Text = "Flex 1 PANEL"; //Drfte egal sein.
            panelFlex1.Dock = DockStyle.Fill;
            panelFlex1.Controls.Add(flex1);
            //panelFlex1.Location = new Point(0, 0);

            c1SplitterPanel1.Controls.Add(panelFlex1);
            c1SplitterPanel1.Dock = PanelDockStyle.Top;

            //this.c1DashboardLayout1.SplitLayoutControl.Panels.Add(c1SplitterPanel1);
            c1SplitContainerLinks.Panels.Add(c1SplitterPanel1);

            this.c1DashboardLayout1.SetCaption(c1SplitterPanel1, "Flex 1");
            this.c1DashboardLayout1.SetId(c1SplitterPanel1, "97e5d98c-d0f5-450b-97c5-5df6499dae16");

            C1SplitterPanel c1SplitterPanel2 = new C1SplitterPanel();
            c1SplitterPanel2.Text = "Split 2";
            c1SplitterPanel2.Name = "c1SplitterPanel2";
            c1SplitterPanel2.SizeRatio = 50;

            MyFlex2 flex2 = new MyFlex2();
            flex2.Dock = DockStyle.Fill;
            Panel panelFlex2 = new Panel();
            //Padding/Margin:
            panelFlex2.Text = "Flex 2 PANEL";
            panelFlex2.Dock = DockStyle.Fill;
            //panelFlex2.Size = new Size(200, 100);
            //panelFlex2.Location = new Point(200, 0);
            panelFlex2.Controls.Add(flex2);
            c1SplitterPanel2.Controls.Add(panelFlex2);

            c1SplitContainerLinks.Panels.Add(c1SplitterPanel2);

            this.c1DashboardLayout1.SetCaption(c1SplitterPanel2, "Flex 2");
            this.c1DashboardLayout1.SetId(c1SplitterPanel2, "97e5d98c-d0f5-450b-97c5-5df6499dae17");


            C1SplitterPanel c1SplitterPanel3 = new C1SplitterPanel();
            c1SplitterPanel3.Text = "Split 3";
            c1SplitterPanel3.Name = "c1SplitterPanel3";

            MyFlex2 flex3 = new MyFlex2();
            flex3.Dock = DockStyle.Fill;
            Panel panelFlex3 = new Panel();
            //Padding/Margin:
            panelFlex3.Text = "Flex 3 PANEL";
            panelFlex3.Dock = DockStyle.Fill;
            panelFlex3.Controls.Add(flex3);
            c1SplitterPanel3.Controls.Add(panelFlex3);

            c1SplitContainerLinks.Panels.Add(c1SplitterPanel3);

            this.c1DashboardLayout1.SetCaption(c1SplitterPanel3, "Flex 3");
            this.c1DashboardLayout1.SetId(c1SplitterPanel3, "97e5d98c-d0f5-450b-97c5-5df6499dae07");

            //=============================================================================

            //Level 1 Split rechts:
            C1SplitContainer c1SplitContainerRechts = new C1SplitContainer();
            c1SplitContainerRechts.Dock = DockStyle.Fill;
            c1SplitterPanelRootRechts.Controls.Add(c1SplitContainerRechts);


            //Level 1 Split links:
            C1SplitterPanel c1SplitterPanelRechts1 = new C1SplitterPanel();
            c1SplitterPanelRechts1.Text = "Split rechts 1";
            c1SplitterPanelRechts1.Name = "c1SplitterPanelRechts1";

            MyFlex1 flexRechts1 = new MyFlex1();
            flexRechts1.Dock = DockStyle.Fill;
            Panel panelFlexRechts1 = new Panel();
            //Padding/Margin:
            panelFlexRechts1.Text = "Flex Rechts 1 PANEL"; //Drfte egal sein.
            panelFlexRechts1.Dock = DockStyle.Fill;
            panelFlexRechts1.Controls.Add(flexRechts1);

            c1SplitterPanelRechts1.Controls.Add(panelFlexRechts1);
            c1SplitterPanelRechts1.Dock = PanelDockStyle.Top;


            c1SplitContainerRechts.Panels.Add(c1SplitterPanelRechts1);

            this.c1DashboardLayout1.SetCaption(c1SplitterPanelRechts1, "Flex rechts 1");
            this.c1DashboardLayout1.SetId(c1SplitterPanelRechts1, "97e5d98c-d0f5-450b-97c5-5df6499dae18");

            C1SplitterPanel c1SplitterPanelRechts2 = new C1SplitterPanel();
            c1SplitterPanelRechts2.Text = "Split rechts 2";
            c1SplitterPanelRechts2.Name = "c1SplitterPanelRechts2";

            MyFlex2 flexRechts2 = new MyFlex2();
            flexRechts2.Dock = DockStyle.Fill;
            Panel panelFlexRechts2 = new Panel();
            //Padding/Margin:
            panelFlexRechts2.Text = "Flex Rechts 2 PANEL";
            panelFlexRechts2.Dock = DockStyle.Fill;
            //panelFlex2.Size = new Size(200, 100);
            //panelFlex2.Location = new Point(200, 0);
            panelFlexRechts2.Controls.Add(flexRechts2);
            c1SplitterPanelRechts2.Controls.Add(panelFlexRechts2);

            c1SplitContainerRechts.Panels.Add(c1SplitterPanelRechts2);

            this.c1DashboardLayout1.SetCaption(c1SplitterPanelRechts2, "Flex rechts 2");
            this.c1DashboardLayout1.SetId(c1SplitterPanelRechts2, "97e5d98c-d0f5-450b-97c5-5df6499dae19");


            //Test: auch die Root-Container kriegen IDs:
            this.c1DashboardLayout1.SetId(c1SplitterPanelRootLinks, "97e5d98c-d0f5-450b-97c5-5df6499dae00");
            this.c1DashboardLayout1.SetId(c1SplitterPanelRootRechts, "97e5d98c-d0f5-450b-97c5-5df6499dae01");

            this.c1DashboardLayout1.SplitLayoutControl.ResumeLayout(true);
            this.c1DashboardLayout1.ResumeLayout(true);

            this.c1DashboardLayout1.Controls[0].ContextMenuStrip!.Opening += ContextMenuStrip_Opening;
        }

        private void ContextMenuStrip_Opening(object? sender, System.ComponentModel.CancelEventArgs e)
        {
            var strip = (sender as ContextMenuStrip)!;
            e.Cancel = !strip.Items[0].Available || !strip.Items[1].Available;
        }

        private void buttonSaveLayout_Click(object sender, EventArgs e)
        {
            this.c1DashboardLayout1.SaveLayout("layout_split.xml");
        }

        private void buttonLoadLayout_Click(object sender, EventArgs e)
        {
            this.c1DashboardLayout1.LoadLayout("layout_split.xml");

        }
    }
}
